/**
 * Browshot API
 * Take screenshots of any website in real time
 *
 * OpenAPI spec version: 1.16.0
 * Contact: support@browshot.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

package io.swagger.client.api

import io.swagger.client.model.Batch
import io.swagger.client.model.BatchError
import java.io.File
import io.swagger.client.ApiInvoker
import io.swagger.client.ApiException

import com.sun.jersey.multipart.FormDataMultiPart
import com.sun.jersey.multipart.file.FileDataBodyPart

import javax.ws.rs.core.MediaType

import java.io.File
import java.util.Date

import scala.collection.mutable.HashMap

class BatchApi(val defBasePath: String = "https://api.browshot.com/api/v1",
                        defApiInvoker: ApiInvoker = ApiInvoker) {
  var basePath = defBasePath
  var apiInvoker = defApiInvoker

  def addHeader(key: String, value: String) = apiInvoker.defaultHeaders += key -> value 

  /**
   * Requests thousands of screenshtos at once
   * Get hundreds or thousands of screenshots from a text file. You can use this API call or the dashboard. Unlike the other API calls, you must issue a POST request with the Content-Type \&quot;multipart/form-data\&quot; in order to upload the text file. The text file must contain the list of URLs to request, 1 URL per line. Failed screenshots will be tried up to 3 times before giving up. 
   * @param instanceId instance ID to use 
   * @param file text file to use (optional)
   * @param size screenshots size - \&quot;screen\&quot; (default) or \&quot;page\&quot; (optional, default to screen)
   * @param name name of the batch (optional)
   * @param width thumbnail width. (optional, default to 1024)
   * @param height thumbnail height (optional)
   * @param delay number of seconds to wait after the page has loaded. This is used to let JavaScript run longer before taking the screenshot. Use delay&#x3D;0 to take screenshots faster. (optional, default to 5)
   * @param flashDelay number of seconds to wait after the page has loaded if Flash elements are present. Use flash_delay&#x3D;0 to take screenshots faster. (optional, default to 10)
   * @param screenWidth width of the browser window. For desktop browsers only. (optional, default to 1024)
   * @param screenHeight height of the browser window. For desktop browsers only. (Note: full-page screenshots can have a height of up to 15,000px) (optional, default to 768)
   * @param priority assign priority to the screenshot (for private instances only) (optional)
   * @param referer use a custom referrer header - paid screenshots only (optional)
   * @param postData send a POST requests with post_data, useful for filling out forms - paid screenshots only (optional)
   * @param cookie set a cookie for the URL requested (see Custom POST Data, Referer and Cookie) Cookies should be separated by a ; - paid screenshots only (optional)
   * @param script URL of javascript file to execute after the page load event (optional)
   * @param details level of information available with screenshot/info (optional, default to 2)
   * @param html saves the HTML of the rendered page which can be retrieved by the API call screenshot/html. This feature costs *1 credit* per screenshot. (optional, default to 0)
   * @param maxWait maximum number of seconds to wait before triggering the PageLoad event. Note that delay will still be used. (default: 0 &#x3D; disabled) (optional, default to 0)
   * @param headers any custom HTTP headers. (Not supported with Internet Explorer) (optional)
   * @param format image as PNG or JPEG (optional, default to png)
   * @param shots take multiple screenshots of the same page. This costs 1 additional credit for every 2 additional screenshots. (optional, default to 1)
   * @param shotInterval number of seconds between 2 screenshots (optional, default to 5)
   * @return List[Batch]
   */
  def batchCeatePost(instanceId: Integer, file: Option[File] = None, size: Option[String] /* = screen*/, name: Option[String] = None, width: Option[Integer] /* = 1024*/, height: Option[Integer] = None, delay: Option[Integer] /* = 5*/, flashDelay: Option[Integer] /* = 10*/, screenWidth: Option[Integer] /* = 1024*/, screenHeight: Option[Integer] /* = 768*/, priority: Option[Integer] = None, referer: Option[String] = None, postData: Option[String] = None, cookie: Option[String] = None, script: Option[String] = None, details: Option[Integer] /* = 2*/, html: Option[Integer] /* = 0*/, maxWait: Option[Integer] /* = 0*/, headers: Option[String] = None, format: Option[String] /* = png*/, shots: Option[Integer] /* = 1*/, shotInterval: Option[Integer] /* = 5*/): Option[List[Batch]] = {
    // create path and map variables
    val path = "/batch/ceate".replaceAll("\\{format\\}", "json")

    val contentTypes = List("multipart/form-data")
    val contentType = contentTypes(0)

    val queryParams = new HashMap[String, String]
    val headerParams = new HashMap[String, String]
    val formParams = new HashMap[String, String]

    

    var postBody: AnyRef = null

    if (contentType.startsWith("multipart/form-data")) {
      val mp = new FormDataMultiPart
      mp.field("instance_id", instanceId.toString, MediaType.MULTIPART_FORM_DATA_TYPE)
      file.map(fileVal => mp.field("file", fileVal.getName))
      file.map(paramVal => mp.bodyPart(new FileDataBodyPart("file", paramVal, MediaType.MULTIPART_FORM_DATA_TYPE)))
      size.map(paramVal => mp.field("size", paramVal.toString, MediaType.MULTIPART_FORM_DATA_TYPE))
      name.map(paramVal => mp.field("name", paramVal.toString, MediaType.MULTIPART_FORM_DATA_TYPE))
      width.map(paramVal => mp.field("width", paramVal.toString, MediaType.MULTIPART_FORM_DATA_TYPE))
      height.map(paramVal => mp.field("height", paramVal.toString, MediaType.MULTIPART_FORM_DATA_TYPE))
      delay.map(paramVal => mp.field("delay", paramVal.toString, MediaType.MULTIPART_FORM_DATA_TYPE))
      flashDelay.map(paramVal => mp.field("flash_delay", paramVal.toString, MediaType.MULTIPART_FORM_DATA_TYPE))
      screenWidth.map(paramVal => mp.field("screen_width", paramVal.toString, MediaType.MULTIPART_FORM_DATA_TYPE))
      screenHeight.map(paramVal => mp.field("screen_height", paramVal.toString, MediaType.MULTIPART_FORM_DATA_TYPE))
      priority.map(paramVal => mp.field("priority", paramVal.toString, MediaType.MULTIPART_FORM_DATA_TYPE))
      referer.map(paramVal => mp.field("referer", paramVal.toString, MediaType.MULTIPART_FORM_DATA_TYPE))
      postData.map(paramVal => mp.field("post_data", paramVal.toString, MediaType.MULTIPART_FORM_DATA_TYPE))
      cookie.map(paramVal => mp.field("cookie", paramVal.toString, MediaType.MULTIPART_FORM_DATA_TYPE))
      script.map(paramVal => mp.field("script", paramVal.toString, MediaType.MULTIPART_FORM_DATA_TYPE))
      details.map(paramVal => mp.field("details", paramVal.toString, MediaType.MULTIPART_FORM_DATA_TYPE))
      html.map(paramVal => mp.field("html", paramVal.toString, MediaType.MULTIPART_FORM_DATA_TYPE))
      maxWait.map(paramVal => mp.field("max_wait", paramVal.toString, MediaType.MULTIPART_FORM_DATA_TYPE))
      headers.map(paramVal => mp.field("headers", paramVal.toString, MediaType.MULTIPART_FORM_DATA_TYPE))
      format.map(paramVal => mp.field("format", paramVal.toString, MediaType.MULTIPART_FORM_DATA_TYPE))
      shots.map(paramVal => mp.field("shots", paramVal.toString, MediaType.MULTIPART_FORM_DATA_TYPE))
      shotInterval.map(paramVal => mp.field("shot_interval", paramVal.toString, MediaType.MULTIPART_FORM_DATA_TYPE))
      postBody = mp
    } else {
      formParams += "instance_id" -> instanceId.toString
      size.map(paramVal => formParams += "size" -> paramVal.toString)
      name.map(paramVal => formParams += "name" -> paramVal.toString)
      width.map(paramVal => formParams += "width" -> paramVal.toString)
      height.map(paramVal => formParams += "height" -> paramVal.toString)
      delay.map(paramVal => formParams += "delay" -> paramVal.toString)
      flashDelay.map(paramVal => formParams += "flash_delay" -> paramVal.toString)
      screenWidth.map(paramVal => formParams += "screen_width" -> paramVal.toString)
      screenHeight.map(paramVal => formParams += "screen_height" -> paramVal.toString)
      priority.map(paramVal => formParams += "priority" -> paramVal.toString)
      referer.map(paramVal => formParams += "referer" -> paramVal.toString)
      postData.map(paramVal => formParams += "post_data" -> paramVal.toString)
      cookie.map(paramVal => formParams += "cookie" -> paramVal.toString)
      script.map(paramVal => formParams += "script" -> paramVal.toString)
      details.map(paramVal => formParams += "details" -> paramVal.toString)
      html.map(paramVal => formParams += "html" -> paramVal.toString)
      maxWait.map(paramVal => formParams += "max_wait" -> paramVal.toString)
      headers.map(paramVal => formParams += "headers" -> paramVal.toString)
      format.map(paramVal => formParams += "format" -> paramVal.toString)
      shots.map(paramVal => formParams += "shots" -> paramVal.toString)
      shotInterval.map(paramVal => formParams += "shot_interval" -> paramVal.toString)
    }

    try {
      apiInvoker.invokeApi(basePath, path, "POST", queryParams.toMap, formParams.toMap, postBody, headerParams.toMap, contentType) match {
        case s: String =>
           Some(apiInvoker.deserialize(s, "array", classOf[Batch]).asInstanceOf[List[Batch]])
        case _ => None
      }
    } catch {
      case ex: ApiException if ex.code == 404 => None
      case ex: ApiException => throw ex
    }
  }

  /**
   * Get the batch status
   * Get the status of a batch requested through the API or through the dashboard. 
   * @param id batch ID 
   * @return Batch
   */
  def batchInfoGet(id: Integer): Option[Batch] = {
    // create path and map variables
    val path = "/batch/info".replaceAll("\\{format\\}", "json")

    val contentTypes = List("application/json")
    val contentType = contentTypes(0)

    val queryParams = new HashMap[String, String]
    val headerParams = new HashMap[String, String]
    val formParams = new HashMap[String, String]

    queryParams += "id" -> id.toString
    

    var postBody: AnyRef = null

    if (contentType.startsWith("multipart/form-data")) {
      val mp = new FormDataMultiPart
      postBody = mp
    } else {
    }

    try {
      apiInvoker.invokeApi(basePath, path, "GET", queryParams.toMap, formParams.toMap, postBody, headerParams.toMap, contentType) match {
        case s: String =>
           Some(apiInvoker.deserialize(s, "", classOf[Batch]).asInstanceOf[Batch])
        case _ => None
      }
    } catch {
      case ex: ApiException if ex.code == 404 => None
      case ex: ApiException => throw ex
    }
  }

}
